//*****************************************************************************
//* Copyright (c) 2002-2005 Miday Workshop All rights reserved.
//*
//* File: CommonDB.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

static unsigned char *Yasumi_mem;

struct db_data_d {
	short year;
	short month;
	unsigned char red[31];
} saizitu_d;

static DmOpenRef dbP;

static unsigned long Yasumib[31] = {
 0x00000001, 0x00000002, 0x00000004, 0x00000008, 0x00000010, 0x00000020, 0x00000040, 0x00000080,
 0x00000100, 0x00000200, 0x00000400, 0x00000800, 0x00001000, 0x00002000, 0x00004000, 0x00008000,
 0x00010000, 0x00020000, 0x00040000, 0x00080000, 0x00100000, 0x00200000, 0x00400000, 0x00800000,
 0x01000000, 0x02000000, 0x04000000, 0x08000000, 0x10000000, 0x20000000, 0x40000000 };

//Version 3.2 Add Start
//--------------------------------------------------------
//@f[^t@CύX
//  "Data file" name change.
//--------------------------------------------------------
void file_name_change() {
	Err err = errNone;
	unsigned short recordNo = 0;
	char   filename[33];
	LocalID dbIDP[2];
	short old_file, new_file;
	UInt16 dmVer;
	UInt16 dmAttr;

	Boolean newsearch;
	DmSearchStateType stateInfop;

	old_file = 0;
	new_file = 0;
	newsearch = true;
	for ( ;; ) {
		err = DmGetNextDatabaseByTypeCreator(newsearch, &stateInfop, Dt_DBType,
				Dt_CreaID, false, &cardNo, &dbIDP[0] );

		if ( err != 0 ) break;

		err = DmDatabaseInfo(cardNo, dbIDP[0], filename, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		if ( StrCompare(filename, Dt_FileName_old ) == 0 ) {
			old_file = 1;
			dbIDP[1] = dbIDP[0];
		}
		if ( StrCompare(filename, Dt_FileName ) == 0 ) {
			new_file = 1;
		}
		newsearch = false;
	}

	if( new_file == 1 ) {
		if( old_file == 1 ) {
			FileDelete(cardNo, Dt_FileName_old);//Delete
		}
	} else {
		if( old_file == 1 ) {
			dmAttr = dmHdrAttrBackup;
			dmVer  = Md_DBVersion;//DataBase Version
			DmSetDatabaseInfo(cardNo, dbIDP[1], Dt_FileName, &dmAttr, &dmVer, NULL,
			                  NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		}
	}
}
//Version 3.2 Add End

//--------------------------------------------------------
//@FR[ht@C
//  "Color file" name input.
//--------------------------------------------------------
void ColorFileNameGet() {
	Err err = errNone;
	unsigned short recordNo = 0;
	char   filename[33];
	unsigned short file_key, category;
	short  offset;
	MemHandle recHdl;
	void *recPtr;
	struct db_version {
		short ver;
	} version;

	Boolean newsearch;
	DmSearchStateType stateInfop;

	file_key = StrLen(Col_FileName);

	Col_data_no = 0;
	newsearch = true;
	for ( ;; ) {
		err = DmGetNextDatabaseByTypeCreator(newsearch, &stateInfop, Df_ClType,
				Df_CreaID, false, &cardNo, &Col_dbIDP[Col_data_no] );

		if ( err != 0 ) break;

		err = DmDatabaseInfo(cardNo, Col_dbIDP[Col_data_no], filename, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		MemMove(&Col_file[Col_data_no][0], &filename[file_key], StrLen(filename)-file_key-4);
		Col_file[Col_data_no][StrLen(filename)-file_key-4] = '\0';
		dbP = DmOpenDatabase ( cardNo, Col_dbIDP[Col_data_no], dmModeReadOnly);
		if (dbP==NULL) {
//WinDrawChars ("WWWW", 4, 20, 20);//G[̂Ƃ
		}

		category = 1;
		offset   = 0;
		recordNo = 0;
		if ( DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category) == 0 ) {
			recHdl = DmQueryRecord (dbP, recordNo);
			recPtr = MemHandleLock(recHdl);
			MemMove(&version.ver, recPtr, 2 );//f[^̃o[W荞    (Version taking in)
			MemHandleUnlock(recHdl);
			DmCloseDatabase ( dbP );
			if ( version.ver <= Md_Version ) {//f[^̃o[W`FbN    (Version check)
					Col_data_no++;
					if ( Col_data_no >= Max_Color_File_no ) {
						break;
					}
			}
		} else {
			DmCloseDatabase ( dbP );
		}

		newsearch = false;
	}
}

//--------------------------------------------------------
//@t@C邩`FbN
//  It is confirmed that there is a file.
//--------------------------------------------------------
short FileCheck(short flag, char *file_check) {
//flag           =1 xt@C  =2 Ff[^t@C    (=1 Holiday file  =2 Color file)
//file_check     Ff[^t@C̎At@C        (File name(Only in flag=2, it is used.))
	unsigned short cardNo;
	Err err = errNone;
	unsigned short recordNo = 0;
	char filename[33];
	short find_flag;
	LocalID wk_dbIDP;
	unsigned long  w_type, w_creator;

	Boolean newsearch;
	DmSearchStateType stateInfop;

	newsearch = true;
	find_flag = 0;

	if ( flag == 1 ) {
		w_type    = Dt_DBType;
		w_creator = Dt_CreaID;
	} else {
		w_type    = Df_ClType;
		w_creator = Df_CreaID;
	}

	for ( ;; ) {
		err = DmGetNextDatabaseByTypeCreator(newsearch, &stateInfop, w_type,
				w_creator, false, &cardNo, &wk_dbIDP );
		if ( err != 0 ) break;
		err = DmDatabaseInfo(cardNo, wk_dbIDP, filename, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		if ( flag == 1 ) {
			find_flag = 1;
			break;
		} else {
			if ( StrCompare(file_check, filename) == 0 ) {
				find_flag = 1;
				break;
			}
		}
		newsearch = false;
	}
	return find_flag;
}

//--------------------------------------------------------
//@w͈͂̋xf[^WɕύX
//  The holiday data of the specified range is changed into standard documentation.
//--------------------------------------------------------
short GetRedBeamData(short all_flag, short *start_year, short *start_month, short *end_year,
                     short *end_month, unsigned long *standard_data, short *no) {
//all_flag       =1 Sf[^  =2 wf[^   (=1 All data  =2 Select data)
//start_year     JnN                       (Start year)
//start_month    Jn                       (Start month)
//end_year       IN                       (End year)
//end_month      I                       (End month)
//standard_data  W                     (Standard form)
//no            f[^̌                  (The number of the months)
	short id, ic, flag;

	id = 0;
	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	if ( all_flag == 1 ) {
		*start_year  = 9999;
		*start_month = 12;
		*end_year    = 0;
		*end_month   = 1;
	}

	for ( ic=0; ic<Yasumi_no; ic++) {
		MemMove(&saizitu_d.year, &Yasumi_mem[ic*35], 35 );
		if ( all_flag == 1 ) {
			RedData_Compresses(Color_win_max_color, &Yasumi_mem[ic*35+4],
			                   &standard_data[id*(Color_win_max_color+1)+1], &flag);
			MemMove(&standard_data[id*(Color_win_max_color+1)], &saizitu_d.year, 4);
			if ( flag == 1 ) {
				id = id + 1;
				if ( ( saizitu_d.year < *start_year ) ||
				     ( saizitu_d.year == *start_year && saizitu_d.month < *start_month ) ) {
					*start_year  = saizitu_d.year;
					*start_month = saizitu_d.month;
				}
				if ( ( saizitu_d.year > *end_year ) ||
				     ( saizitu_d.year == *end_year && saizitu_d.month > *end_month ) ) {
					*end_year  = saizitu_d.year;
					*end_month = saizitu_d.month;
				}
			}
		} else if ( *start_year != *end_year ) {
			if ( ( saizitu_d.year > *start_year && saizitu_d.year < *end_year ) ||
			     ( saizitu_d.year == *start_year && saizitu_d.month >= *start_month ) ||
			     ( saizitu_d.year == *end_year && saizitu_d.month <= *end_month ) ) {
				RedData_Compresses(Color_win_max_color, &Yasumi_mem[ic*35+4],
				                   &standard_data[id*(Color_win_max_color+1)+1], &flag);
				MemMove(&standard_data[id*(Color_win_max_color+1)], &saizitu_d.year, 4);
				if ( flag == 1 ) id = id + 1;
			}
		} else {
			if ( saizitu_d.year == *start_year &&
			     saizitu_d.month >= *start_month && saizitu_d.month <= *end_month ) {
				RedData_Compresses(Color_win_max_color, &Yasumi_mem[ic*35+4],
				                   &standard_data[id*(Color_win_max_color+1)+1], &flag);
				MemMove(&standard_data[id*(Color_win_max_color+1)], &saizitu_d.year, 4);
				if ( flag == 1 ) id = id + 1;
			}
		}
	}
	MemHandleUnlock(Yasumi_mem_hndl);
	*no = id;
	return 0;
}

//--------------------------------------------------------
//@w͈͂̋xf[^f[g
//  The holiday data of the specified range is deleted.
//--------------------------------------------------------
short DeleteRedDataOfArray(short start_year, short start_month, short end_year, short end_month) {
//start_year     JnN   (Start year)
//start_month    Jn   (Start month)
//end_year       IN   (End year)
//end_month      I   (End month)
	short ic;

	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	for ( ic=0; ic<Yasumi_no; ic++) {
		MemMove(&saizitu_d.year, &Yasumi_mem[ic*35], 35 );
		if ( start_year != end_year ) {
			if ( ( saizitu_d.year > start_year && saizitu_d.year < end_year ) ||
			     ( saizitu_d.year == start_year && saizitu_d.month >= start_month ) ||
			     ( saizitu_d.year == end_year && saizitu_d.month <= end_month ) ) {
				MemSet( &Yasumi_mem[ic*35+4], 31, 0 );
			}
		} else {
			if ( saizitu_d.year == start_year &&
			     saizitu_d.month >= start_month && saizitu_d.month <= end_month ) {
				MemSet( &Yasumi_mem[ic*35+4], 31, 0 );
			}
		}
	}
	MemHandleUnlock(Yasumi_mem_hndl);
	return 0;
}

//--------------------------------------------------------
//@xf[^̐FZbg
//  The color of holiday data is reset. 
//--------------------------------------------------------
short RsetRedDataOfArray(short color1, short color2) {
//color1         JnFԍ    (Start color number)
//color2         IFԍ    (End color number)
	short ib, ic, id, ie, day_no;

	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	ie = 0;
	for ( ib=color1; ib<=color2; ib++) {
		for ( ic=0; ic<Yasumi_no; ic++) {
			MemMove(&saizitu_d.year, &Yasumi_mem[ic*35], 35 );
			GetDayOfTheWeek( saizitu_d.year, saizitu_d.month, &day_no);
			for ( id=0; id<day_no; id++) {
				if ( ( Yasumi_mem[ic*35+id+4] & Color_table_bit[ib-1] ) == Color_table_bit[ib-1] ) {
					if ( ie == 0 ) {
						if ( FrmAlert(AltColorDecreases) == 0 ) {
							ie = 1;
						} else {
							ie = 2;
						}
					}
					if ( ie == 1 ) {
						Yasumi_mem[ic*35+id+4] = 0;
					}
				}
			}
		}
	}
	MemHandleUnlock(Yasumi_mem_hndl);
	return ie;
}

//--------------------------------------------------------
//@xf[^z񂩂荞
//  Holiday data is got from area.
//--------------------------------------------------------
void GetRedDataOfArray(short year, short month, unsigned char *red, short *no) {
//year           oN                    (Year)
//month          o                    (Month)
//red            of[^               (Holiday data)
//no             z̓Yԍ  VḰA-1    (The index number of area.  It is -1 when new.)
	short i;

	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	for ( i=0; i<Yasumi_no; i++) {
		MemMove(&saizitu_d.year, &Yasumi_mem[i*35], 35 );
		if ( month == saizitu_d.month && year == saizitu_d.year ) {
			MemMove(red, saizitu_d.red, 31);
			*no   = i;
			MemHandleUnlock(Yasumi_mem_hndl);
			return;
		}
	}
	MemSet(red, 31, 0);
	*no = -1;
	MemHandleUnlock(Yasumi_mem_hndl);
}

//--------------------------------------------------------
//@xf[^zɃZbg
//  Holiday data is set to area.
//--------------------------------------------------------
short SetRedDataOfArray(short year, short month, unsigned char *red, short no) {
//year           oN                    (Year)
//month          o                    (Month)
//red            of[^              (Holiday data)
//no             z̓Yԍ  VḰA-1  (The index number of area.  It is -1 when new.)
	short ia, ib;

	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	if ( no != -1 ) {
		MemMove(&saizitu_d.year, &Yasumi_mem[no*35], 4 );
		MemMove(saizitu_d.red, red, 31);
		MemMove(&Yasumi_mem[no*35], &saizitu_d.year, 35 );
		MemHandleUnlock(Yasumi_mem_hndl);
		return 0;
	} else {
		ib = 0;
		for ( ia=0; ia<31; ia++ ) {
			if ( red[ia] != 0 ) {
				ib = 1;
				break;
			}
		}
		if ( ib == 1 ) {
			if ( Yasumi_no >= Yasumi_max_no ) {
				Yasumi_max_no = Yasumi_no + 120;
				MemHandleResize(Yasumi_mem_hndl, (Yasumi_max_no)*sizeof(saizitu_d));
			}
			MemMove(saizitu_d.red, red, 31);
			saizitu_d.month = month;
			saizitu_d.year  = year;
			MemMove(&Yasumi_mem[Yasumi_no*35], &saizitu_d.year, 35 );
			Yasumi_no       = Yasumi_no + 1;
		}
		MemHandleUnlock(Yasumi_mem_hndl);
		return 0;
	}
}

//--------------------------------------------------------
//@xf[^WɕύX
//  Holiday data is changed into standard documentation.
//--------------------------------------------------------
void RedData_Compresses(short save_color, unsigned char *local_data, unsigned long *standard_data, short *flag) {
//save_color    F̐                           (The number of colors)
//local_data    [J`                     (Local form)
//standard_data W                         (Standard form)
//flag          =0  SĐFȂ  =1  Ff[^ (=0 There was no color data.  =1 There was color data.)
	short  ib, ic;
	MemSet(standard_data, Max_Color_no * 4, 0 );
	*flag = 0;
	for ( ic=0; ic<31; ic++ ) {
		for ( ib=0; ib<save_color; ib++ ) {
			if ( (local_data[ic] & Color_table_bit[ib]) == Color_table_bit[ib] ) {
				standard_data[ib] = standard_data[ib] | Yasumib[ic];
				*flag = 1;
			}
		}
	}
}

//--------------------------------------------------------
//@xf[^WύX
//  Holiday data is changed from standard documentation.
//--------------------------------------------------------
void RedData_Extends(short save_color, unsigned char *local_data, unsigned long *standard_data) {
//save_color    F̐                           (The number of colors)
//local_data    [J`                     (Local form)
//standard_data W                         (Standard form)
	short ib, ic;
	MemSet(local_data, 31, 0 );
	for ( ib=0; ib<save_color; ib++ ) {
		for ( ic=0; ic<31; ic++ ) {
			if ( (standard_data[ib] & Yasumib[ic]) == Yasumib[ic] ) {
				local_data[ic] = local_data[ic] | Color_table_bit[ib];
			}
		}
	}
}

//--------------------------------------------------------
//@xf[^̐FR[h
//  The color code of holiday data is initialized.
//--------------------------------------------------------
void Md_InitRedDate(short no){
//no             F̔ԍ     (Turn of a color.)
	MemHandle StringH;
	char  *StringP;
	short ia;

	switch(no - 1) {
	case 0:
		Color_def[0].hol_flag = 1;
		Color_def[0].color1_b = 125;
		Color_def[0].color2_b = 3;
		Color_def[0].color1_t = 0;
		Color_def[0].color2_t = 215;
	case 1:
		Color_def[1].hol_flag = 1;
		Color_def[1].color1_b = 207;
		Color_def[1].color2_b = 174;
		Color_def[1].color1_t = 0;
		Color_def[1].color2_t = 215;
	case 2:
		Color_def[2].hol_flag = 1;
		Color_def[2].color1_b = 95;
		Color_def[2].color2_b = 90;
		Color_def[2].color1_t = 0;
		Color_def[2].color2_t = 215;
	case 3:
		Color_def[3].hol_flag = 0;
		Color_def[3].color1_b = 117;
		Color_def[3].color2_b = 115;
		Color_def[3].color1_t = 0;
		Color_def[3].color2_t = 0;
	case 4:
		Color_def[4].hol_flag = 0;
		Color_def[4].color1_b = 17;
		Color_def[4].color2_b = 15;
		Color_def[4].color1_t = 0;
		Color_def[4].color2_t = 215;
	case 5:
		Color_def[5].hol_flag = 0;
		Color_def[5].color1_b = 120;
		Color_def[5].color2_b = 108;
		Color_def[5].color1_t = 215;
		Color_def[5].color2_t = 215;
	case 6:
		Color_def[6].hol_flag = 0;
		Color_def[6].color1_b = 160;
		Color_def[6].color2_b = 140;
		Color_def[6].color1_t = 0;
		Color_def[6].color2_t = 0;
	}

	for ( ia=no-1; ia<Max_Color_no; ia++ ) {
		StringH = DmGetResource(strRsc, StringColor1 + ia*100);
		StringP = MemHandleLock(StringH);
		StrCopy(Color_def[ia].text, StringP);
		MemHandleUnlock(StringH);
		if (OS_Color_Support == 1) {//Color?
			WinIndexToRGB( Color_def[ia].color1_b, &Color_def[ia].rgbcolor1_b);
			WinIndexToRGB( Color_def[ia].color1_t, &Color_def[ia].rgbcolor1_t);
			WinIndexToRGB( Color_def[ia].color2_b, &Color_def[ia].rgbcolor2_b);
			WinIndexToRGB( Color_def[ia].color2_t, &Color_def[ia].rgbcolor2_t);
		}
	}

	if ( no == 1 ) {
		Color_win_max_color = Max_Color_no;
		if (OS_Color_Support == 1) {//Color?
			Color_dev_type = 6;
		} else {
			Color_dev_type = 1;
		}
	}
}

//--------------------------------------------------------
//@xf[^荞
//  Holiday data is input.
//--------------------------------------------------------
void Md_GetDatabase(short flag, char *file_name){
//flag           =1 xt@C  =2 Ff[^t@C    (=1 Holiday file  =2 Color file)
//file_check     Ff[^t@C̎At@C        (File name(Only in flag=2, it is used.))
	unsigned short cardNo = 0;
	Err err = errNone;
	MemHandle     recHdl;
	void          *recPtr;
	unsigned char *recChar;
	unsigned short recordNo = 0;
	DmOpenRef dbP;
	LocalID dbIDP;
	short   offset;
	unsigned short	category;
	unsigned long in_work[8], st_byte, en_byte, xintlMgrExists;
	short ia, id, ie, ix, iz;

	struct db_version {
		short ver;
	} version;
//	struct db_data_s {
//		short year1;
//		short month1;
//		short year2;
//		short month2;
//	} saizitu_s;
	struct db_data_c {
		short byte_len;
		short color_no;
		short color_type;
	} saizitu_c;

	if ( flag == 1 ) {
		dbP = DmOpenDatabaseByTypeCreator ( Dt_DBType, Dt_CreaID, dmModeReadOnly);
	} else {
		dbIDP = DmFindDatabase (cardNo, file_name);

		dbP = DmOpenDatabase(cardNo, dbIDP, dmModeReadOnly);
	}
	if (dbP == NULL) {
		if ( flag == 1 ) {
			Yasumi_no = 0;
			Yasumi_max_no = 120;
			Yasumi_mem_hndl = MemHandleNew((Yasumi_max_no)*sizeof(saizitu_d));
			Md_InitRedDate(1);
		}
		return;
	}

	//JeS[P荞  (Category 1)
	if ( flag == 1 ) {
		category = 1;
		offset   = 0;
		recordNo = 0;
		DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category);
		recHdl = DmQueryRecord (dbP, recordNo);
		recPtr = MemHandleLock(recHdl);
		MemMove(&version.ver, recPtr, 2 );//f[^̃o[W荞    (Version taking in)
		MemHandleUnlock(recHdl);
		Max_over_color_flag = 0;
		Max_over_text_flag  = 0;
	}
	if ( version.ver <= Md_Version || flag == 2 ) {//f[^̃o[W`FbN    (Version check)
//JeS[Q荞  (Category 2)
//		category = 2;
//		offset   = 0;
//		recordNo = 0;
//		DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category);
//		recHdl = DmQueryRecord (dbP, recordNo);
//		recPtr = MemHandleLock(recHdl);
//		MemMove(&saizitu_s.year1, recPtr, 8 );//f[^͈͎̔荞
//		MemHandleUnlock(recHdl);

		//JeS[R荞  (Category 3)
		if ( version.ver == 3 || flag == 2 ) {//f[^̃o[W3
			category = 3;
			offset   = 0;
			recordNo = 0;
			if ( DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category) == 0 ) {
				recHdl = DmQueryRecord (dbP, recordNo);
				if ( recHdl != 0 ) {
					recChar = MemHandleLock(recHdl);
					MemMove(&saizitu_c.byte_len,  recChar, 6);
					Color_dev_type = saizitu_c.color_type;
					ie = 6;
					for ( id=0; id<saizitu_c.color_no; id++ ) {
						ie = ie + 2;
						MemMove(&Color_def[id].hol_flag,  &recChar[ie], 22);
						ie = ie + 22;
					}
					if ( saizitu_c.color_no > Max_Color_no ) {
						ie = ie + ( saizitu_c.color_no - Max_Color_no ) *  22;
						saizitu_c.color_no = Max_Color_no;
						FrmAlert(AltColorOverLoad);
						Max_over_color_flag = 1;
					}
					for ( id=0; id<saizitu_c.color_no; id++ ) {
						ix = recChar[ie];
						ie = ie + 1;

						if ( ix >= Max_ColorText_no ) {
							if ( Max_over_text_flag == 0 ) {
								FrmAlert(AltTextOverLoad);
							}

							if ( FtrGet(sysFtrCreator, sysFtrNumIntlMgr, &xintlMgrExists) != 0 ) xintlMgrExists = 0;
							if ( xintlMgrExists ) {

								TxtCharBounds((char*)&recChar[ie], Max_ColorText_no-2, &st_byte, &en_byte);
								if ( en_byte == Max_ColorText_no-1 ) {
									ix = Max_ColorText_no - 1;
								} else {
									ix = Max_ColorText_no - 2;
								}
							} else {
								for ( iz=0; iz<ix; iz++ ) {//Japanese(Shift JIS) or English only
									if ((recChar[iz+ie+1]>=0x81 && recChar[iz+ie+1]<=0x9f) ||
									    (recChar[iz+ie+1]>=0xe0 && recChar[iz+ie+1]<=0xfc)) {
										if ( iz+1 >= Max_ColorText_no-1 ) {
											ix = iz;
											break;
										}
										iz++;
									}
									if ( iz >= Max_ColorText_no-1 ) {
										ix = iz;
										break;
									}
								}
							}

							Max_over_text_flag = 1;
						}
						MemMove(&Color_def[id].text[0], &recChar[ie], ix);
						Color_def[id].text[ix] = '\0';
						ie = ie + recChar[ie-1];
					}

					MemHandleUnlock(recHdl);
				}
			} else {
				if ( flag == 1 ) {
					Md_InitRedDate(1);
					saizitu_c.color_no = 2;
				}
			}
		} else {
			Md_InitRedDate(1);
			saizitu_c.color_no = 2;
		}
		Color_win_max_color = saizitu_c.color_no;

		//JeS[S荞  (Category 4)
		if ( flag == 1 ) {
			category = 4;
			offset   = 0;
			recordNo = 0;
			for (ia=0; ia<32760; ia++ ) {//Pʂ̃f[^`FbN    (The number of data is checked.)
				if ( DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category) != 0 ) break;
				recHdl = DmQueryRecord (dbP, recordNo);
				if ( recHdl == 0 ) break;
				Yasumi_no = Yasumi_no + 1;
				offset    = 1;
			}

			Yasumi_max_no = Yasumi_no+120;
			Yasumi_mem_hndl = MemHandleNew((Yasumi_max_no)*sizeof(saizitu_d));
			offset   = 0;
			recordNo = 0;
			for (ia=0; ia<Yasumi_no; ia++ ) {//Pʂ̃f[^荞    (Data is inputted.)
				if ( DmSeekRecordInCategory(dbP, &recordNo, offset, dmSeekForward, category) != 0 ) break;
				recHdl = DmQueryRecord (dbP, recordNo);
				if ( recHdl == 0 ) break;
				recChar = MemHandleLock(recHdl);
				Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
				MemMove(&in_work, recChar, Color_win_max_color*4+4 );
				MemMove(&Yasumi_mem[ia*35], in_work, 4 );

				RedData_Extends(Color_win_max_color, &Yasumi_mem[ia*35+4], &in_work[1]);

				MemHandleUnlock(recHdl);
				MemHandleUnlock(Yasumi_mem_hndl);
				offset = 1;
			}
		}
	} else {
		Yasumi_no     = 0;
		Yasumi_max_no = 120;
		Yasumi_mem_hndl = MemHandleNew((Yasumi_max_no)*sizeof(saizitu_d));
		Md_InitRedDate(1);
	}
	DmCloseDatabase (dbP);
}

//--------------------------------------------------------
//@Jn@I`FbN
//  The start/end month is checked.
//--------------------------------------------------------
static short Md_CheckRedDate(){
	short st_year, st_month, en_year, en_month;
	short ia, ib, ix, iy;

	Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
	iy = 0;
	for ( ix=0; ix<Yasumi_no; ix++ ) {
//		MemMove(&saizitu_d.year, &Yasumi_mem[ix*12], 12 );   V3.2 Debug
//		if ( ix == 0 ) {
//			st_year  = saizitu_d.year;
//			st_month = saizitu_d.month;
//			en_year  = saizitu_d.year;
//			en_month = saizitu_d.month;
//		}
//		if ( saizitu_d.year < st_year || ( saizitu_d.year == st_year && saizitu_d.month < st_month ) ) {
//			st_year  = saizitu_d.year;
//			st_month = saizitu_d.month;
//		}
//		if ( saizitu_d.year > en_year || ( saizitu_d.year == en_year && saizitu_d.month > en_month ) ) {
//			en_year  = saizitu_d.year;
//			en_month = saizitu_d.month;
//		}
//		ib = 0;
//		for ( ia=0; ia<31; ia++ ) {
//			if ( saizitu_d.red[ia] != 0 ) {
//				ib = 1;
//				break;
//			}
//		}
//		if ( ib == 1 ) {
//			iy = 1;
//		}
		MemMove(&saizitu_d.year, &Yasumi_mem[ix*35], 35 );
		ib = 0;
		for ( ia=0; ia<31; ia++ ) {
			if ( saizitu_d.red[ia] != 0 ) {
				ib = 1;
				break;
			}
		}
		if ( ib == 1 ) {
			if ( iy == 0 ) {
				st_year  = saizitu_d.year;
				st_month = saizitu_d.month;
				en_year  = saizitu_d.year;
				en_month = saizitu_d.month;
			}
			if ( saizitu_d.year < st_year || ( saizitu_d.year == st_year && saizitu_d.month < st_month ) ) {
				st_year  = saizitu_d.year;
				st_month = saizitu_d.month;
			}
			if ( saizitu_d.year > en_year || ( saizitu_d.year == en_year && saizitu_d.month > en_month ) ) {
				en_year  = saizitu_d.year;
				en_month = saizitu_d.month;
			}
			iy = 1;
		}
	}

	if ( iy == 1 ) {
		Sv_st_year  = st_year;
		Sv_st_month = st_month;
		Sv_en_year  = en_year;
		Sv_en_month = en_month;
		Sv_month_no = (Sv_en_year - Sv_st_year)*12 + Sv_en_month - Sv_st_month + 1;
	}

	MemHandleUnlock(Yasumi_mem_hndl);
	if ( iy == 0 ) {
		return 2;
	}
	return 0;
}

//--------------------------------------------------------
//@xf[^i[
//  Holiday data is output.
//--------------------------------------------------------
short Md_SetDatabase(short flag, char *file_name){
//flag           =1 xt@C  =2 Ff[^t@C  (=1 Holiday file  =2 Color file)
//file_name      t@C                            (File name) 

//  ̃f[^珇ɓĂ    (It outputs from the last data.)
	struct db_data_d {
		short year;
		short month;
		unsigned long red[7];
	} saizitu_d;

	LocalID dbIDP;
	MemHandle recordH;
	Err       err;
	void    *recordP;
	unsigned short newIndex, attr;
	long   reclen;
	short  category, save_color, s_data[4], ia, id, ie, ix, iy, iz;
	unsigned char out_work[301];
	//Version 3.2 Add Start
	UInt16 dmVer;
	UInt16 dmAttr;
	//Version 3.2 Add End

	cardNo = 0;

	FileDelete(cardNo, file_name);

	if ( flag == 1 ) {
		err = DmCreateDatabase (cardNo, file_name, Dt_CreaID, Dt_DBType, false);
	} else {
		err = DmCreateDatabase (cardNo, file_name, Df_CreaID, Df_ClType, false);
	}
	if (err) {
		return 1;
	}

	dbIDP = DmFindDatabase (cardNo, file_name);

	//Version 3.2 Add Start
	dmAttr = dmHdrAttrBackup;
	dmVer  = Md_DBVersion;//DataBase Version
	DmSetDatabaseInfo(cardNo, dbIDP, NULL, &dmAttr, &dmVer, NULL,
	                  NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	//Version 3.2 Add End

	if ( flag == 1 ) {
		dbP = DmOpenDatabaseByTypeCreator(Dt_DBType, Dt_CreaID, dmModeReadWrite);
	} else {
		dbP = DmOpenDatabase(cardNo, dbIDP, dmModeReadWrite);
	}
	if (dbP==NULL) {
		return 1;
	}

	//JeS[S֊i[  (Category 4)
	if ( flag == 1 ) {
		if ( Opt_g.data_ver == 3 ) {
			save_color = Color_win_max_color;
		} else {
			save_color = 2;
		}
		reclen   = save_color * 4 + 4;
		category = 4;

		Yasumi_mem = MemHandleLock(Yasumi_mem_hndl);
		iz = 0;
		for ( ix=0;ix<Yasumi_no;ix++) {
			MemMove(&saizitu_d.year, &Yasumi_mem[ix*35],  4 );
			MemMove(out_work, &Yasumi_mem[ix*35+4], 31 );
		
			RedData_Compresses(save_color, out_work, saizitu_d.red, &iy);

			if ( iy == 1 ) {
				iz = 1;

				recordH = DmNewHandle(dbP, reclen);
				if (recordH == NULL) {
					return dmErrMemError;
				}
				recordP = MemHandleLock(recordH);
				DmWrite (recordP, 0, &saizitu_d.year, reclen);

				err = DmAttachRecord(dbP, &newIndex, recordH, 0);
				if (err) {
					MemHandleUnlock(recordH);
					return 1;
				}

				DmRecordInfo (dbP, newIndex, &attr, NULL, NULL);
				attr &= ~dmRecAttrCategoryMask;
				attr |= category;
				DmSetRecordInfo (dbP, newIndex, &attr, NULL);
				MemHandleUnlock(recordH);
			}
		}
		MemHandleUnlock(Yasumi_mem_hndl);
	}

	//JeS[R֊i[  (Category 3)
	if ( Opt_g.data_ver == 3 ) {
		category  = 3;
		MemMove(&out_work[2], &Color_win_max_color, 2 );
		MemMove(&out_work[4], &Color_dev_type, 2 );

		reclen = 6;
		for ( id=1; id<Color_win_max_color+1; id++ ) {
			MemMove(&out_work[reclen], &id, 2 );
			reclen = reclen + 2;
			MemMove(&out_work[reclen], &Color_def[id-1].hol_flag, 22 );
			if ( Opt_g.hol_count_flag == 0 ) {
				out_work[reclen] = 0;
			}
			reclen = reclen + 22;
		}
		for ( id=1; id<Color_win_max_color+1; id++ ) {
			ie = StrLen(Color_def[id-1].text);
			out_work[reclen] = ie;
			MemMove(&out_work[reclen+1], Color_def[id-1].text, ie);
			reclen = reclen + ie + 1;
		}
		ia = reclen;
		MemMove(&out_work[0], &ia, 2 );

		recordH = DmNewHandle(dbP, reclen);
		if (recordH == NULL) {
			return dmErrMemError;
		}
		recordP = MemHandleLock(recordH);
		DmWrite (recordP, 0, &out_work[0], reclen);

		err = DmAttachRecord(dbP, &newIndex, recordH, 0);
		if (err) {
			MemHandleUnlock(recordH);
			return 1;
		}

		DmRecordInfo (dbP, newIndex, &attr, NULL, NULL);
		attr &= ~dmRecAttrCategoryMask;
		attr |= category;
		DmSetRecordInfo (dbP, newIndex, &attr, NULL);
		MemHandleUnlock(recordH);
	}

	//JeS[Q֊i[  (Category 2)
	if ( flag == 1 ) {
		Md_CheckRedDate();
		reclen    = 8;
		category  = 2;
		s_data[0] = Sv_st_year;
		s_data[1] = Sv_st_month;
		s_data[2] = Sv_en_year;
		s_data[3] = Sv_en_month;
		recordH = DmNewHandle(dbP, reclen);
		if (recordH == NULL) {
			return dmErrMemError;
		}
		recordP = MemHandleLock(recordH);
		DmWrite (recordP, 0, &s_data[0], reclen);

		err = DmAttachRecord(dbP, &newIndex, recordH, 0);
		if (err) {
			MemHandleUnlock(recordH);
			return 1;
		}

		DmRecordInfo (dbP, newIndex, &attr, NULL, NULL);
		attr &= ~dmRecAttrCategoryMask;
		attr |= category;
		DmSetRecordInfo (dbP, newIndex, &attr, NULL);
		MemHandleUnlock(recordH);
	}

	//JeS[P֊i[  (Category 1)
	reclen   = 2;
	category = 1;
	if ( Opt_g.data_ver == 3 || flag == 2 ) {
		s_data[0]  = Md_Version;
	} else {
		if ( Sv_month_no > 36 ) {
			s_data[0]  = 2;
		} else {
			s_data[0]  = 1;
		}
	}
	recordH = DmNewHandle(dbP, reclen);
	if (recordH == NULL) {
		return dmErrMemError;
	}
	recordP = MemHandleLock(recordH);
	DmWrite (recordP, 0, &s_data[0], reclen);

	err = DmAttachRecord(dbP, &newIndex, recordH, 0);
	if (err) {
		MemHandleUnlock(recordH);
		return 1;
	}

	DmRecordInfo (dbP, newIndex, &attr, NULL, NULL);
	attr &= ~dmRecAttrCategoryMask;
	attr |= category;
	DmSetRecordInfo (dbP, newIndex, &attr, NULL);
	MemHandleUnlock(recordH);

	err = DmCloseDatabase(dbP);
	return 0;
}
