//*****************************************************************************
//* Copyright (c) 2002-2005 Miday Workshop All rights reserved.
//*
//* File: Memorial.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define X_LEFT  81
#define X_RIGHT 133
#define Y_LEFTS 27
#define Y_LEFTD 30
#define X_SELC  8
#define Y_SELC  8

static short TopCheckBoxs[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1CheckBox, MemorialWinSp2CheckBox,
	  MemorialWinSp3CheckBox, MemorialWinSp4CheckBox };
static short HolidayCheckBoxs[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1HolidayCheckBox, MemorialWinSp2HolidayCheckBox,
	  MemorialWinSp3HolidayCheckBox, MemorialWinSp4HolidayCheckBox };
static short Color1CategoryLists[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1Color1CategoryList, MemorialWinSp2Color1CategoryList,
	  MemorialWinSp3Color1CategoryList, MemorialWinSp4Color1CategoryList };
static short Color1CategoryTriggers[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1Color1CategoryTrigger, MemorialWinSp2Color1CategoryTrigger,
	  MemorialWinSp3Color1CategoryTrigger, MemorialWinSp4Color1CategoryTrigger };
static short Color2CategoryLists[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1Color2CategoryList, MemorialWinSp2Color2CategoryList,
	  MemorialWinSp3Color2CategoryList, MemorialWinSp4Color2CategoryList };
static short Color2CategoryTriggers[MAX_MEMORIAL_DEFNO] = 
	{ MemorialWinSp1Color2CategoryTrigger, MemorialWinSp2Color2CategoryTrigger,
	  MemorialWinSp3Color2CategoryTrigger, MemorialWinSp4Color2CategoryTrigger };

static short YearCategoryLists[MAX_MEMORIAL_DEFNO] = 
	{ MemorialWinSp1YearCategoryList, MemorialWinSp2YearCategoryList,
	  MemorialWinSp3YearCategoryList, MemorialWinSp4YearCategoryList };
static short YearCategoryTriggers[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1YearCategoryTrigger, MemorialWinSp2YearCategoryTrigger,
	  MemorialWinSp3YearCategoryTrigger, MemorialWinSp4YearCategoryTrigger };
static short MonthCategoryLists[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1MonthCategoryList, MemorialWinSp2MonthCategoryList,
	  MemorialWinSp3MonthCategoryList, MemorialWinSp4MonthCategoryList };
static short MonthCategoryTriggers[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1MonthCategoryTrigger, MemorialWinSp2MonthCategoryTrigger,
	  MemorialWinSp3MonthCategoryTrigger, MemorialWinSp4MonthCategoryTrigger };
static short DayCategoryLists[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1DayCategoryList, MemorialWinSp2DayCategoryList,
	  MemorialWinSp3DayCategoryList, MemorialWinSp4DayCategoryList };
static short DayCategoryTriggers[MAX_MEMORIAL_DEFNO] =
	{ MemorialWinSp1DayCategoryTrigger, MemorialWinSp2DayCategoryTrigger,
	  MemorialWinSp3DayCategoryTrigger, MemorialWinSp4DayCategoryTrigger };
static char **Memorial_Year_table[MAX_MEMORIAL_DEFNO] = 
	{ memorial1_Year_table, memorial2_Year_table,
	  memorial3_Year_table, memorial4_Year_table };
static char **Memorial_Month_table[MAX_MEMORIAL_DEFNO] = 
	{ memorial1_Month_table, memorial2_Month_table,
	  memorial3_Month_table, memorial4_Month_table };
static char **Memorial_Day_table[MAX_MEMORIAL_DEFNO] = 
	{ memorial1_Day_table, memorial2_Day_table,
	  memorial3_Day_table, memorial4_Day_table };

static short Color_week[Max_Color_no+1], Color_hol[Max_Color_no+1], Color_week_no, Color_hol_no;

static short Back_memorial_flag[MAX_MEMORIAL_DEFNO], Back_memorial_hol_flag[MAX_MEMORIAL_DEFNO],
      Back_memorial_year[MAX_MEMORIAL_DEFNO], Back_memorial_month[MAX_MEMORIAL_DEFNO],
      Back_memorial_day[MAX_MEMORIAL_DEFNO], Back_memorial_col1[MAX_MEMORIAL_DEFNO],
      Back_memorial_col2[MAX_MEMORIAL_DEFNO];

//--------------------------------------------------------
//@݂̐FR[h\
//  The present color code is displayed. 
//--------------------------------------------------------
static void ColorRectDisp (short ia, short ib){
//ia             FR[h      (The number of the Color code)
//ib             LO̔ԍ  (The number of a memorial day)
	RectangleType r_col;
	short ic;

	r_col.extent.x  = X_SELC;
	r_col.extent.y  = Y_SELC;
	if ( ib < MAX_MEMORIAL_DEFNO ) {
//̏ꍇ  (left)
		r_col.topLeft.x = X_LEFT;
		r_col.topLeft.y = ib*Y_LEFTD+Y_LEFTS;
		if ( ia != 90 ) {
			if ( Opt_g.memorial_flag[ib] != 0 ) {
				if ( Opt_g.hol_count_flag == 1 ) {
					ColorRectDisp2 (ia, r_col);
				}
			}
		} else {
			if (OS_Color_Support == 1) {//Color?
				WinSetBackColor(BackColor);
				WinSetForeColor(BackColor);
				WinFillRectangle(&r_col, 0);
				WinSetForeColor(TextColor);
			} else {
				for ( ic=0; ic<9; ic++ ) {
					WinEraseLine (r_col.topLeft.x+ic, r_col.topLeft.y, r_col.topLeft.x+ic, r_col.topLeft.y+9);
				}
			}
		}
	} else {
//Ȅꍇ  (Right)
		r_col.topLeft.x = X_RIGHT;
		r_col.topLeft.y = (ib-MAX_MEMORIAL_DEFNO)*Y_LEFTD+Y_LEFTS;
		if ( ia != 90 ) {
			if ( Opt_g.memorial_flag[ib-MAX_MEMORIAL_DEFNO] != 0 ) {
				if ( Opt_g.hol_count_flag != 1 || Opt_g.memorial_hol_flag[ib-MAX_MEMORIAL_DEFNO] == 0 ) {
					ColorRectDisp2 (ia, r_col);
				}
			}
		} else {
			if (OS_Color_Support == 1) {//Color?
				WinSetBackColor(BackColor);
				WinSetForeColor(BackColor);
				WinFillRectangle(&r_col, 0);
				WinSetForeColor(TextColor);
			} else {
				for ( ic=0; ic<9; ic++ ) {
					WinEraseLine (r_col.topLeft.x+ic, r_col.topLeft.y, r_col.topLeft.x+ic, r_col.topLeft.y+9);
				}
			}
		}
	}
}

//--------------------------------------------------------
//@Ẽ`FbN{bNX̃I^It؂ւ
//  Change processing of a right-hand side check box.
//--------------------------------------------------------
static void check_on_off2(short no) {
//no             LO̔ԍ  (The number of a memorial day)

	if ( Opt_g.memorial_flag[no] == 0 ) {
		CtlSetEnabled(GetObjectPtr(Color2CategoryTriggers[no]), false);
		CtlHideControl(GetObjectPtr(Color2CategoryTriggers[no]));
		ColorRectDisp (90, no+MAX_MEMORIAL_DEFNO);
	} else {
		if ( Opt_g.memorial_hol_flag[no] == 0 ) {
			CtlSetEnabled(GetObjectPtr(Color2CategoryTriggers[no]), true);
			CtlShowControl(GetObjectPtr(Color2CategoryTriggers[no]));
			ColorRectDisp (Opt_g.memorial_col2[no], no+MAX_MEMORIAL_DEFNO);
		} else {
			CtlSetEnabled(GetObjectPtr(Color2CategoryTriggers[no]), false);
			CtlHideControl(GetObjectPtr(Color2CategoryTriggers[no]));
			ColorRectDisp (90, no+MAX_MEMORIAL_DEFNO);
		}
	}
}

//--------------------------------------------------------
//@̃`FbN{bNX̃I^It؂ւ
//  Change processing of a left-hand side check box 
//--------------------------------------------------------
static void check_on_off1(short no) {
//no             LO̔ԍ  (The number of a memorial day)

	if ( Opt_g.memorial_flag[no] == 0 ) {
		CtlHideControl(GetObjectPtr(HolidayCheckBoxs[no]));
		CtlHideControl(GetObjectPtr(Color1CategoryTriggers[no]));
		CtlSetEnabled(GetObjectPtr(YearCategoryTriggers[no]),   false);
		CtlSetEnabled(GetObjectPtr(MonthCategoryTriggers[no]),  false);
		CtlSetEnabled(GetObjectPtr(DayCategoryTriggers[no]),    false);
		ColorRectDisp (90, no);
	} else {
		if ( Opt_g.hol_count_flag == 1 ) {
			CtlShowControl(GetObjectPtr(HolidayCheckBoxs[no]));
			CtlShowControl(GetObjectPtr(Color1CategoryTriggers[no]));
			ColorRectDisp (Opt_g.memorial_col1[no], no);
		} else {
			CtlHideControl(GetObjectPtr(HolidayCheckBoxs[no]));
			CtlHideControl(GetObjectPtr(Color1CategoryTriggers[no]));
			ColorRectDisp (90, no);
		}
		CtlSetEnabled(GetObjectPtr(YearCategoryTriggers[no]),   true);
		CtlSetEnabled(GetObjectPtr(MonthCategoryTriggers[no]),  true);
		CtlSetEnabled(GetObjectPtr(DayCategoryTriggers[no]),    true);
	}
	check_on_off2(no);
}

//--------------------------------------------------------
//@J[XgCxgnhOij
//  Event handling of "color list".(weekday)
//--------------------------------------------------------
static void MemorialWinColorList1 (short index, RectangleType *boundsP, char **itemsText) {
	ColorList (index, boundsP, Color_hol_no, Color_hol[index-1]);
}

//--------------------------------------------------------
//@J[XgCxgnhOixj
//  Event handling of "color list".(holiday)
//--------------------------------------------------------
static void MemorialWinColorList2 (short index, RectangleType *boundsP, char **itemsText) {
	ColorList (index, boundsP, Color_week_no, Color_week[index-1]);
}

//--------------------------------------------------------
//@gK[\̈悩`FbN
//  It checks in the "trigger display domain".
//--------------------------------------------------------
static short ColorRectCheck (short ix, short iy){
	short ia;

	if ( Opt_g.hol_count_flag == 1 ) {
		if (ix>=X_LEFT && ix<=X_LEFT+X_SELC) {
			for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
				if (iy>=Y_LEFTS+ia*Y_LEFTD && iy<=Y_LEFTS+Y_SELC+ia*Y_LEFTD) {
					return ia;
				}
			}
		}
	}
	if (ix>=X_RIGHT && ix<=X_RIGHT+X_SELC) {
		for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
			if (iy>=Y_LEFTS+ia*Y_LEFTD && iy<=Y_LEFTS+Y_SELC+ia*Y_LEFTD) {
				if ( Opt_g.memorial_flag[ia] == 1 && Opt_g.memorial_hol_flag[ia] == 0 ) {
					return ia+MAX_MEMORIAL_DEFNO;
				} else {
					return 99;
				}
			}
		}
	}
	return 99;
}

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void MemorialWinInit (){
	FontID fontsize;
	char work[20];
	short start_year, ix, ia;
	MemHandle StringH;
	char      *StringP;

	start_year = Start_year;

	WinSetUnderlineMode(noUnderline);
	fontsize = FntSetFont(stdFont);

	//N  (Year)
	for ( ix=0; ix<Year_no+1; ix++ ) {
		memorial1_Year_table[ix] = memorial1_Year_data[ix];
		memorial2_Year_table[ix] = memorial2_Year_data[ix];
		memorial3_Year_table[ix] = memorial3_Year_data[ix];
		memorial4_Year_table[ix] = memorial4_Year_data[ix];
	}

	for (ix=0; ix<Year_no; ix++) {
		StrIToA(work, start_year+ix);
		StrCat(work, Year_suffix);
		StrCopy(memorial1_Year_data[ix], work);
		StrCopy(memorial2_Year_data[ix], work);
		StrCopy(memorial3_Year_data[ix], work);
		StrCopy(memorial4_Year_data[ix], work);
	}
	StringH = DmGetResource(strRsc, StringEVERYYEAR);
	StringP = MemHandleLock(StringH);
	StrCopy(work, StringP);
	MemHandleUnlock(StringH);
	StrCopy(memorial1_Year_data[Year_no], work);
	StrCopy(memorial2_Year_data[Year_no], work);
	StrCopy(memorial3_Year_data[Year_no], work);
	StrCopy(memorial4_Year_data[Year_no], work);

	for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
		lstTable = (ListType *)GetObjectPtr(YearCategoryLists[ia]);
		LstSetListChoices(lstTable, Memorial_Year_table[ia], Year_no+1);
		LstSetHeight(lstTable, Year_no+1);
		if ( Opt_g.memorial_year[ia] == 2999 ) {
			Opt_g.memorial_year[ia] = Start_year + 10;
		}
		if ( Opt_g.memorial_year[ia]-Start_year >= 0 && Opt_g.memorial_year[ia]-Start_year <= 10 ) {
			LstSetSelection(lstTable, Opt_g.memorial_year[ia]-Start_year);
			CtlSetLabel(GetObjectPtr(YearCategoryTriggers[ia]),LstGetSelectionText(lstTable, Opt_g.memorial_year[ia]-Start_year));
		} else {
			LstSetSelection(lstTable, 2);
			CtlSetLabel(GetObjectPtr(YearCategoryTriggers[ia]),LstGetSelectionText(lstTable, 2));
		}
	}

	//  (Month)
	for ( ix=0; ix<Month_no; ix++ ) {
		Start_Month_table[ix]     = Start_Month_data[ix];
		End_Month_table[ix]       = End_Month_data[ix];
		memorial1_Month_table[ix] = memorial1_Month_data[ix];
		memorial2_Month_table[ix] = memorial2_Month_data[ix];
		memorial3_Month_table[ix] = memorial3_Month_data[ix];
		memorial4_Month_table[ix] = memorial4_Month_data[ix];

		StrIToA(work, ix+1);
		StrCat(work, Month_suffix);
		StrCopy(Start_Month_data[ix],     work);
		StrCopy(End_Month_data[ix],       work);
		StrCopy(memorial1_Month_data[ix], work);
		StrCopy(memorial2_Month_data[ix], work);
		StrCopy(memorial3_Month_data[ix], work);
		StrCopy(memorial4_Month_data[ix], work);
	}

	for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
		lstTable = (ListType *)GetObjectPtr(MonthCategoryLists[ia]);
		LstSetListChoices(lstTable, Memorial_Month_table[ia], Month_no);
		LstSetHeight(lstTable, Month_no);
		LstSetSelection(lstTable, Opt_g.memorial_month[ia]-1);
		CtlSetLabel(GetObjectPtr(MonthCategoryTriggers[ia]),LstGetSelectionText(lstTable, Opt_g.memorial_month[ia]-1));
	}

	//  (Day)
	memorial1_Day_no = 31;
	memorial2_Day_no = 31;
	memorial3_Day_no = 31;
	memorial4_Day_no = 31;

	for ( ix=0; ix< memorial1_Day_no; ix++ ) {
		memorial1_Day_table[ix] = memorial1_Day_data[ix];
		memorial2_Day_table[ix] = memorial2_Day_data[ix];
		memorial3_Day_table[ix] = memorial3_Day_data[ix];
		memorial4_Day_table[ix] = memorial4_Day_data[ix];

		StrIToA(work, ix+1);
		StrCat(work, Day_suffix);
		StrCopy(memorial1_Day_data[ix], work);
		StrCopy(memorial2_Day_data[ix], work);
		StrCopy(memorial3_Day_data[ix], work);
		StrCopy(memorial4_Day_data[ix], work);
	}

	for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
		lstTable = (ListType *)GetObjectPtr(DayCategoryLists[ia]);
		LstSetListChoices(lstTable, Memorial_Day_table[ia], memorial1_Day_no);
		LstSetHeight(lstTable, memorial1_Day_no);
		LstSetSelection(lstTable, Opt_g.memorial_day[ia]-1);
		CtlSetLabel(GetObjectPtr(DayCategoryTriggers[ia]), LstGetSelectionText(lstTable, Opt_g.memorial_day[ia]-1));
	}

	//F  (Color)
	if ( Opt_g.hol_count_flag == 1 ) {
		Color_week_no = 0;
		Color_hol_no  = 0;
		for ( ia=0; ia<Color_win_max_color; ia++ ) {
			if ( Color_def[ia].hol_flag == 0 ) {
				Color_week[Color_week_no] = ia;
				Color_week_no             = Color_week_no + 1;
			} else {
				Color_hol[Color_hol_no]   = ia;
				Color_hol_no              = Color_hol_no  + 1;
			}
		}
	} else {
		for ( ia=0; ia<Color_win_max_color+1; ia++ ) {
			Color_week[ia] = ia;
			Color_hol[ia]  = ia;
		}
		Color_week_no = Color_win_max_color;
		Color_hol_no  = Color_win_max_color;
	}

	for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
		lstTable = (ListType *)GetObjectPtr(Color1CategoryLists[ia]);
		LstSetListChoices(lstTable, Color_w_table,Color_hol_no+2);
		LstSetHeight(lstTable, Color_hol_no+2);
		LstSetSelection(lstTable, Opt_g.memorial_col1[ia]);

		lstTable = (ListType *)GetObjectPtr(Color2CategoryLists[ia]);
		LstSetListChoices(lstTable, Color_h_table, Color_week_no+2);
		LstSetHeight(lstTable, Color_week_no+2);
		LstSetSelection(lstTable, Opt_g.memorial_col2[ia]);

		CtlSetValue(GetObjectPtr(HolidayCheckBoxs[ia]),Opt_g.memorial_hol_flag[ia]);
		CtlSetValue(GetObjectPtr(TopCheckBoxs[ia]),Opt_g.memorial_flag[ia]);

		check_on_off1(ia);

		LstSetDrawFunction(GetObjectPtr(Color1CategoryLists[ia]), MemorialWinColorList1);
		LstSetDrawFunction(GetObjectPtr(Color2CategoryLists[ia]), MemorialWinColorList2);
		check_on_off2(ia);
	}
}

//--------------------------------------------------------
//@tB[`̈f[^ݒ菈
//  Data setting of a feature.
//--------------------------------------------------------
static void Feature_Data_Set() {
	short ia;

	for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
		lstTable = (ListType *)GetObjectPtr(YearCategoryLists[ia]);
		Opt_g.memorial_year[ia]  = LstGetSelection(lstTable) + Start_year;
		if ( LstGetSelection(lstTable) == 10 ) Opt_g.memorial_year[ia] = 2999;
		lstTable = (ListType *)GetObjectPtr(MonthCategoryLists[ia]);
		Opt_g.memorial_month[ia] = LstGetSelection(lstTable) + 1;
		lstTable = (ListType *)GetObjectPtr(DayCategoryLists[ia]);
		Opt_g.memorial_day[ia]   = LstGetSelection(lstTable) + 1;
	}
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean MemorialWinHandleEvent (EventType * event){
	Boolean handled = false;
	short list_no, area_no, year, month, box_no, ia, id, ix;

	frm = FrmGetFormPtr (MemorialWin);

	if (event->eType == penDownEvent){
		area_no = ColorRectCheck(event->screenX, event->screenY);
		if (area_no != 99) {//FgI  (The rectangle beside a trigger?)
			if ( area_no < MAX_MEMORIAL_DEFNO ) {
				if ( Opt_g.memorial_flag[area_no] != 0 ) {
					list_no = LstPopupList(GetObjectPtr(Color1CategoryLists[area_no]));
					if ( list_no == Color_hol_no + 1 ) {
						Color_call_win = 3;
						FrmGotoForm (ColorDefine);
					} else if ( list_no >= 0 ) {
						if ( list_no == 0 ) {
							Opt_g.memorial_col1[area_no] = 0;
						} else {
							Opt_g.memorial_col1[area_no] = Color_hol[list_no-1]+1;
						}
						ColorRectDisp (Opt_g.memorial_col1[area_no], area_no);
					}
				}
			} else {
				if ( Opt_g.memorial_flag[area_no-MAX_MEMORIAL_DEFNO] != 0 && Opt_g.memorial_hol_flag[area_no-MAX_MEMORIAL_DEFNO] == 0 ) {
					list_no = LstPopupList(GetObjectPtr(Color2CategoryLists[area_no-MAX_MEMORIAL_DEFNO]));
					if ( list_no == Color_week_no + 1 ) {
						Color_call_win = 3;
						FrmGotoForm (ColorDefine);
					} else if ( list_no >= 0 ) {
						if ( list_no == 0 ) {
							Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO] = 0;
						} else {
							Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO] = Color_week[list_no-1]+1;
						}
						ColorRectDisp (Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO], area_no);
					}
				}
			}
		}

	} else if (event->eType == penUpEvent){

	} else if (event->eType == keyDownEvent){
//		if (EvtKeydownIsVirtual(event)) {
//			if (event->data.keyDown.chr == vchrJogUp || //WO
//			    event->data.keyDown.chr == vchrPageUp) {//{^
//			} else if (event->data.keyDown.chr == vchrJogDown || //WO
//			           event->data.keyDown.chr == vchrPageDown) {//{^
//			} else if (event->data.keyDown.chr == vchrJogPush ||//WO
//			           event->data.keyDown.chr == vchrJogPushRepeat ||//WO
//			           event->data.keyDown.chr == vchrJogPushedUp ||//WO
//			           event->data.keyDown.chr == vchrJogPushedDown ) {//WO
//			}
//		}

	} else if (event->eType == popSelectEvent){
		area_no = 99;
		switch (event->data.ctlSelect.controlID){
		case MemorialWinSp1YearCategoryTrigger:
		case MemorialWinSp1MonthCategoryTrigger:
			if ( area_no == 99 ) area_no = 0;
		case MemorialWinSp2YearCategoryTrigger:
		case MemorialWinSp2MonthCategoryTrigger:
			if ( area_no == 99 ) area_no = 1;
		case MemorialWinSp3YearCategoryTrigger:
		case MemorialWinSp3MonthCategoryTrigger:
			if ( area_no == 99 ) area_no = 2;
		case MemorialWinSp4YearCategoryTrigger:
		case MemorialWinSp4MonthCategoryTrigger:
			if ( area_no == 99 ) area_no = 3;

			lstTable = (ListType *)GetObjectPtr(YearCategoryLists[area_no]);
			year = LstGetSelection(lstTable) + Start_year;
			lstTable = (ListType *)GetObjectPtr(MonthCategoryLists[area_no]);
			month = LstGetSelection(lstTable) + 1;
			id = GetDayOfTheWeek(year, month, &ix);

			lstTable = (ListType *)GetObjectPtr(DayCategoryLists[area_no]);
			LstSetListChoices(lstTable, Memorial_Day_table[area_no], ix);
			LstSetHeight(lstTable, ix);
			LstSetSelection(lstTable, 0);
			CtlSetLabel(GetObjectPtr(DayCategoryTriggers[area_no]), LstGetSelectionText(lstTable, 0));

			if ( area_no == 0 ) {
				memorial1_Day_no = ix;
			} else if ( area_no == 1 ) {
				memorial2_Day_no = ix;
			} else if ( area_no == 2 ) {
				memorial3_Day_no = ix;
			} else if ( area_no == 3 ) {
				memorial4_Day_no = ix;
			}
//			handled = true;
			break;

		case MemorialWinSp1Color1CategoryTrigger:
			if ( area_no == 99 ) area_no = 0;
		case MemorialWinSp2Color1CategoryTrigger:
			if ( area_no == 99 ) area_no = 1;
		case MemorialWinSp3Color1CategoryTrigger:
			if ( area_no == 99 ) area_no = 2;
		case MemorialWinSp4Color1CategoryTrigger:
			if ( area_no == 99 ) area_no = 3;
			lstTable = (ListType *)GetObjectPtr(Color1CategoryLists[area_no]);
			if ( LstGetSelection(lstTable) == Color_hol_no + 1 ) {
				Color_call_win = 3;
				FrmGotoForm (ColorDefine);
			} else if ( LstGetSelection(lstTable) >= 0 ) {
				if ( LstGetSelection(lstTable) == 0 ) {
					Opt_g.memorial_col1[area_no] = 0;
				} else {
					Opt_g.memorial_col1[area_no] = Color_hol[LstGetSelection(lstTable)-1]+1;
				}
				ColorRectDisp (Opt_g.memorial_col1[area_no], area_no);
			}
			break;

		case MemorialWinSp1Color2CategoryTrigger:
			if ( area_no == 99 ) area_no = 4;
		case MemorialWinSp2Color2CategoryTrigger:
			if ( area_no == 99 ) area_no = 5;
		case MemorialWinSp3Color2CategoryTrigger:
			if ( area_no == 99 ) area_no = 6;
		case MemorialWinSp4Color2CategoryTrigger:
			if ( area_no == 99 ) area_no = 7;
			lstTable = (ListType *)GetObjectPtr(Color2CategoryLists[area_no-MAX_MEMORIAL_DEFNO]);
			if ( LstGetSelection(lstTable) == Color_week_no + 1 ) {
				Color_call_win = 3;
				FrmGotoForm (ColorDefine);
			} else if ( LstGetSelection(lstTable) >= 0 ) {
				if ( LstGetSelection(lstTable) == 0 ) {
					Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO] = 0;
				} else {
					Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO] = Color_week[LstGetSelection(lstTable)-1]+1;
				}
				ColorRectDisp (Opt_g.memorial_col2[area_no-MAX_MEMORIAL_DEFNO], area_no);
			}
		}

	} else if (event->eType == ctlSelectEvent){
		switch (event->data.ctlSelect.controlID){
		case MemorialWinSetButton:
			Dataupdateflag = 1;
			Feature_Data_Set();
			Back_md_flag = 1;
			FrmGotoForm (Model);
			break;
		case MemorialWinCancelButton:
			MemMove( Opt_g.memorial_flag,     Back_memorial_flag,     8);
			MemMove( Opt_g.memorial_hol_flag, Back_memorial_hol_flag, 8);
			MemMove( Opt_g.memorial_year,     Back_memorial_year,     8);
			MemMove( Opt_g.memorial_month,    Back_memorial_month,    8);
			MemMove( Opt_g.memorial_day,      Back_memorial_day,      8);
			MemMove( Opt_g.memorial_col1,     Back_memorial_col1,     8);
			MemMove( Opt_g.memorial_col2,     Back_memorial_col2,     8);
			Back_md_flag = 1;
			FrmGotoForm (Model);
			break;

		case MemorialWinSp1CheckBox:
		case MemorialWinSp2CheckBox:
		case MemorialWinSp3CheckBox:
		case MemorialWinSp4CheckBox:
			box_no = (event->data.ctlSelect.controlID-MemorialWinSp1CheckBox)/20;
			Opt_g.memorial_flag[box_no] = CtlGetValue(GetObjectPtr(TopCheckBoxs[box_no]));
			check_on_off1(box_no);
			break;

		case MemorialWinSp1HolidayCheckBox:
		case MemorialWinSp2HolidayCheckBox:
		case MemorialWinSp3HolidayCheckBox:
		case MemorialWinSp4HolidayCheckBox:
			box_no = (event->data.ctlSelect.controlID-MemorialWinSp1HolidayCheckBox)/20;
			Opt_g.memorial_hol_flag[box_no] = CtlGetValue(GetObjectPtr(HolidayCheckBoxs[box_no]));
			check_on_off2(box_no);
			break;
		}

	}else if (event->eType == menuEvent){
		switch (event->data.menu.itemID){
		case Option3ColorDefCmd:
			Color_call_win = 3;
			FrmGotoForm(ColorDefine);
			break;
		case Option3AboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	}else if (event->eType == frmOpenEvent){
		if ( Back_me_flag == 0 ) {
			MemMove( Back_memorial_flag,     Opt_g.memorial_flag,     8);
			MemMove( Back_memorial_hol_flag, Opt_g.memorial_hol_flag, 8);
			MemMove( Back_memorial_year,     Opt_g.memorial_year,     8);
			MemMove( Back_memorial_month,    Opt_g.memorial_month,    8);
			MemMove( Back_memorial_day,      Opt_g.memorial_day,      8);
			MemMove( Back_memorial_col1,     Opt_g.memorial_col1,     8);
			MemMove( Back_memorial_col2,     Opt_g.memorial_col2,     8);
		}
		Back_me_flag = 0;
		MemorialWinInit ();
		if ( Opt_g.hol_count_flag == 1 ) {
			CtlSetLabel(GetObjectPtr(MemorialWinWeekLabel), WeekString);
			CtlSetLabel(GetObjectPtr(MemorialWinHolLabel),  HolDefString);
		} else {
			CtlSetLabel(GetObjectPtr(MemorialWinWeekLabel), " ");
			CtlSetLabel(GetObjectPtr(MemorialWinHolLabel),  " ");
			for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
				Opt_g.memorial_hol_flag[ia] = 0;
				Opt_g.memorial_col1[ia]     = 0;
			}
		}
		for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
			check_on_off1(ia);
		}

		FrmDrawForm (frm);
		WinDrawLine (0,  50, 160,  50);
		WinDrawLine (0,  80, 160,  80);
		WinDrawLine (0, 110, 160, 110);
		WinDrawLine (0, 140, 160, 140);
		for ( ia=0; ia<MAX_MEMORIAL_DEFNO; ia++ ) {
			ColorRectDisp (Opt_g.memorial_col1[ia], ia);
			ColorRectDisp (Opt_g.memorial_col2[ia], ia+MAX_MEMORIAL_DEFNO);
		}
		handled = true;

	}else if (event->eType == frmUpdateEvent){
	}

	return (handled);
}
