//*****************************************************************************
//* Copyright (c) 2002-2005 Miday Workshop All rights reserved.
//*
//* File: Model.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define X_WEEKS 46
#define Y_WEEKS 38
#define Y_WEEKD 13
#define X_HOLS 104
#define Y_HOLS 132
//Version 3.3 Add Start
#define X_EASTER 104
#define Y_EASTER 146
//Version 3.3 Add End
#define X_SELC 8
#define Y_SELC 8

#define X_WEEK_CHAR 80
#define Y_WEEK_CHAR 35
#define X_HOL_CHAR 128
#define Y_HOL_CHAR 129
//Version 3.3 Add Start
#define X_EASTER_CHAR 128
#define Y_EASTER_CHAR 143
//Version 3.3 Add End

//Version 3.3 Update Start
static short ModelWeekColorCategoryLists[9] = 
	{ ModelSunColorCategoryList, ModelMonColorCategoryList,
	  ModelTueColorCategoryList, ModelWedColorCategoryList,
	  ModelThuColorCategoryList, ModelFriColorCategoryList,
	  ModelSatColorCategoryList, ModelNatColorCategoryList, ModelEasterColorCategoryList };
static short ModelWeekColorCategoryTriggers[9] =
	{ ModelSunColorCategoryTrigger, ModelMonColorCategoryTrigger,
	  ModelTueColorCategoryTrigger, ModelWedColorCategoryTrigger,
	  ModelThuColorCategoryTrigger, ModelFriColorCategoryTrigger,
	  ModelSatColorCategoryTrigger, ModelNatColorCategoryTrigger, ModelEasterColorCategoryTrigger };

static short Back_st_year, Back_st_month, Back_en_year, Back_en_month, Back_week_color[WEEK_DAYS_NO], Back_hol_color, Back_easter_color;
//Version 3.3 Update End

//--------------------------------------------------------
//@J[XgCxgnhO
//  Event handring of "color list".
//--------------------------------------------------------
static void ModelColorList (short index, RectangleType *boundsP, char **itemsText) {
	ColorList (index, boundsP, Color_win_max_color, index-1);
}

//--------------------------------------------------------
//@݂̐FR[h\
//  The present color code is displayed. 
//--------------------------------------------------------
static void ColorRectDisp (short ia, short ib){
//ia             FR[h     (The number of the Color code)
//ib             j̔ԍ   (DayOfTheWeek)
	RectangleType r_col;

	if ( ib < WEEK_DAYS_NO ) {
//j̏ꍇ  (Weekday)
		r_col.topLeft.x = X_WEEKS;
		r_col.topLeft.y = ib*Y_WEEKD+Y_WEEKS;
//Version 3.3 Update Start
	} else if ( ib == WEEK_DAYS_NO ) {
//j̏ꍇ  (Holiday)
		r_col.topLeft.x = X_HOLS;
		r_col.topLeft.y = Y_HOLS;
	} else {
//C[X^[̏ꍇ  (Easter)
		r_col.topLeft.x = X_EASTER;
		r_col.topLeft.y = Y_EASTER;
//Version 3.3 Update End
	}
	r_col.extent.x  = X_SELC;
	r_col.extent.y  = Y_SELC;
	ColorRectDisp2 (ia, r_col);
}

//Version 3.3 Add Start
//--------------------------------------------------------
//@Rg
//  A comment is erased.
//--------------------------------------------------------
static void EraseCom(short ix, short iy) {
	RectangleType r_col;
	short ic;
	r_col.topLeft.x = ix;
	r_col.topLeft.y = iy;
	r_col.extent.x  = 25;
	r_col.extent.y  = 10;
	if (OS_Color_Support == 1) {//Color?
		WinSetBackColor(BackColor);
		WinSetForeColor(BackColor);
		WinFillRectangle(&r_col, 0);
		WinSetBackColor(BackColor);
		WinSetForeColor(TextColor);
	} else {
		for ( ic=0; ic<9; ic++ ) {
			WinEraseLine (r_col.topLeft.x+ic, r_col.topLeft.y, r_col.topLeft.x+ic, r_col.topLeft.y+9);
		}
	}
}

//--------------------------------------------------------
//@Rg\
//  A comment is shown.
//--------------------------------------------------------
static void DrawCom(short color_no, short ix, short iy) {
	short label_Len;
	char  *label_char;

	if ( Opt_g.hol_count_flag == 1 ) {
		if ( color_no == 0 ) {
			label_char = WeekString;
		} else {
			if ( Color_def[color_no-1].hol_flag == 0 ) {
				label_char = WeekString;
			} else {
				label_char = HolDefString;
			}
		}
		label_Len = StrLen(label_char);
		WinDrawChars(label_char, label_Len, ix, iy);
	}
}
//Version 3.3 Add End

//--------------------------------------------------------
//@gK[\̈悩`FbN
//  It checks in "trigger display domain".
//--------------------------------------------------------
static short ColorRectCheck (short ix, short iy){
	short ia;

//j  (Weekday)
	if (ix>=X_WEEKS && ix<=X_WEEKS+X_SELC) {
		for ( ia=0; ia<WEEK_DAYS_NO; ia++ ) {
			if (iy>=Y_WEEKS+ia*Y_WEEKD && iy<=Y_WEEKS+Y_SELC+ia*Y_WEEKD) {
				return ia;
			}
		}
	}
//j  (Holiday)
	if (ix>=X_HOLS && ix<=X_HOLS+X_SELC && iy>=Y_HOLS && iy<=Y_HOLS+Y_SELC) {
		return WEEK_DAYS_NO;
	}
//Version 3.3 Add Start
//C[X^[  (Easter)
	if ( Easter == 1 ) {
		if (ix>=X_EASTER && ix<=X_EASTER+X_SELC && iy>=Y_EASTER && iy<=Y_EASTER+Y_SELC) {
			return WEEK_DAYS_NO+1;
		}
	}
//Version 3.3 Add End
	return 99;
}

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void ModelInit (){
	FontID fontsize;
	char work[20];
	short start_year, ix, iy;

	start_year = Start_year;

	WinSetUnderlineMode(noUnderline);
	fontsize = FntSetFont(stdFont);

	//㕔̔N  (Year)
	for ( ix=0; ix<Year_no; ix++ ) {
		Start_Year_table[ix] = Start_Year_data[ix];
		End_Year_table[ix]   = End_Year_data[ix];
	}

	for (ix=0;ix<Year_no;ix++) {
		StrIToA(work, start_year+ix);
		StrCat(work, Year_suffix);
		StrCopy(Start_Year_data[ix],  work);
		StrCopy(End_Year_data[ix],    work);
	}

	lstTable = (ListType *)GetObjectPtr(ModelStartYearCategoryList);
	LstSetListChoices(lstTable, Start_Year_table, Year_no);
	LstSetHeight(lstTable, Year_no);
	if ( Opt_g.st_year-Start_year >= 0 && Opt_g.st_year-Start_year <= 9 ) {
		LstSetSelection(lstTable, Opt_g.st_year-Start_year);
		CtlSetLabel(GetObjectPtr(ModelStartYearCategoryTrigger),LstGetSelectionText(lstTable, Opt_g.st_year-Start_year));
	} else {
		LstSetSelection(lstTable, 2);
		CtlSetLabel(GetObjectPtr(ModelStartYearCategoryTrigger),LstGetSelectionText(lstTable, 2));
	}

	lstTable = (ListType *)GetObjectPtr(ModelEndYearCategoryList);
	LstSetListChoices(lstTable, End_Year_table, Year_no);
	LstSetHeight(lstTable, Year_no);
	if ( Opt_g.en_year-Start_year >= 0 && Opt_g.en_year-Start_year <= 9 ) {
		LstSetSelection(lstTable, Opt_g.en_year-Start_year);
		CtlSetLabel(GetObjectPtr(ModelEndYearCategoryTrigger),LstGetSelectionText(lstTable, Opt_g.en_year-Start_year));
	} else {
		LstSetSelection(lstTable, 2);
		CtlSetLabel(GetObjectPtr(ModelEndYearCategoryTrigger),LstGetSelectionText(lstTable, 2));
	}

	//㕔̌  (Month)
	for ( ix=0; ix<Month_no; ix++ ) {
		Start_Month_table[ix]    = Start_Month_data[ix];
		End_Month_table[ix]      = End_Month_data[ix];
	}

	for (ix=0;ix<Month_no;ix++) {
		StrIToA(work, ix+1);
		StrCat(work, Month_suffix);
		StrCopy(Start_Month_data[ix],  work);
		StrCopy(End_Month_data[ix],    work);
	}
	lstTable = (ListType *)GetObjectPtr(ModelStartMonthCategoryList);
	LstSetListChoices(lstTable, Start_Month_table, Month_no);
	LstSetHeight(lstTable, Month_no);
	LstSetSelection(lstTable, Opt_g.st_month-1);
	CtlSetLabel(GetObjectPtr(ModelStartMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt_g.st_month-1));

	lstTable = (ListType *)GetObjectPtr(ModelEndMonthCategoryList);
	LstSetListChoices(lstTable, End_Month_table, Month_no);
	LstSetHeight(lstTable, Month_no);
	LstSetSelection(lstTable, Opt_g.en_month-1);
	CtlSetLabel(GetObjectPtr(ModelEndMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt_g.en_month-1));

	//jƏj  (Weekday and Holiday)
	for (ix=0;ix<WEEK_DAYS_NO;ix++) {
		lstTable = (ListType *)GetObjectPtr(ModelWeekColorCategoryLists[ix]);
		LstSetSelection(lstTable, Opt_g.week_color[0]);
		CtlSetLabel(GetObjectPtr(ModelWeekColorCategoryTriggers[ix]), LstGetSelectionText(lstTable, Opt_g.week_color[0]));
	}

	lstTable = (ListType *)GetObjectPtr(ModelNatColorCategoryList);
	if ( Opt_g.hol_color != 99 ) {
		CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox),1);
		LstSetSelection(lstTable, Opt_g.hol_color);
		CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, Opt_g.hol_color));
		CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  true);
	} else {
		CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox),0);
		LstSetSelection(lstTable, 0);
		CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
		CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  false);
	}

//Version 3.3 Add Start
	lstTable = (ListType *)GetObjectPtr(ModelEasterColorCategoryList);
	if ( Opt_g.easter_color != 99 ) {
		CtlSetValue(GetObjectPtr(ModelEasterCheckBox),1);
		LstSetSelection(lstTable, Opt_g.easter_color);
		CtlSetLabel(GetObjectPtr(ModelEasterColorCategoryTrigger), LstGetSelectionText(lstTable, Opt_g.easter_color));
		CtlSetEnabled(GetObjectPtr(ModelEasterColorCategoryTrigger),  true);
	} else {
		CtlSetValue(GetObjectPtr(ModelEasterCheckBox),0);
		LstSetSelection(lstTable, 0);
		CtlSetLabel(GetObjectPtr(ModelEasterColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
		CtlSetEnabled(GetObjectPtr(ModelEasterColorCategoryTrigger),  false);
	}

	if ( Easter == 1 ) {
		iy = WEEK_DAYS_NO+2;
	} else {
		iy = WEEK_DAYS_NO+1;
	}
//Version 3.3 Add End

//Version 3.3 Update Start
	for (ix=0;ix<iy;ix++) {
//Version 3.3 Update End
		lstTable = (ListType *)GetObjectPtr(ModelWeekColorCategoryLists[ix]);
		LstSetListChoices(lstTable, Color_table, Color_win_max_color+2);
		LstSetHeight(lstTable, Color_win_max_color+2);
		if ( ix<WEEK_DAYS_NO ) {
			LstSetSelection(lstTable, Opt_g.week_color[ix]);
//Version 3.3 Update Start
		} else if ( ix==WEEK_DAYS_NO ) {
			LstSetSelection(lstTable, Opt_g.hol_color);
		} else {
			LstSetSelection(lstTable, Opt_g.easter_color);
//Version 3.3 Update End
		}

		CtlSetLabel(GetObjectPtr(ModelWeekColorCategoryTriggers[ix]), LstGetSelectionText(lstTable, 0));

		LstSetDrawFunction(GetObjectPtr(ModelWeekColorCategoryLists[ix]), ModelColorList);
	}
}

//--------------------------------------------------------
//@xf[^ݒ菈
//  Setting of holiday data.
//--------------------------------------------------------
static void Hol_data_set(short flag) {
//flag           =0   =1 ǉ    (=0 Init  =1 Add)
	unsigned char Yasumi_red_t[31];
	short sai_no, sai_day[10], Yasumik_t;
	short ia, ib, id, ie, ig, ih, im, ix;

	if ( flag == 0 ) {//{^H  (Init?)
		Yasumi_no = 0;
	}

	for ( ia=Opt_g.st_year; ia<=Opt_g.en_year; ia++ ) {
		for ( ib=0; ib<12; ib++ ) {
			if (ia == Opt_g.st_year && ib+1 < Opt_g.st_month) continue;
			if (ia == Opt_g.en_year && ib+1 > Opt_g.en_month) break;

			GetRedDataOfArray(ia, ib+1, &Yasumi_red_t[0], &Yasumik_t);
			id = GetDayOfTheWeek(ia, ib+1, &ie);
			for ( ig=0; ig<ie; ig++ ) {
				if ( Opt_g.week_color[id] != 0 ) {
					Yasumi_red_t[ig] = Color_table_bit[Opt_g.week_color[id]-1];
				}
				id++;
				if ( id >= WEEK_DAYS_NO ) id = 0;
			}
			if ( Opt_g.hol_color != 0 && Opt_g.hol_color != 99 ) {
				GetHoliday( ia, ib+1, &sai_no, sai_day );
				for ( ig=0; ig<sai_no; ig++ ) {
					Yasumi_red_t[sai_day[ig]-1] = Color_table_bit[Opt_g.hol_color-1];
				}
			}
//Version 3.3 Add Start
			if ( Opt_g.easter_color != 0 && Opt_g.easter_color != 99 ) {
				EasterGet( ia, &im, sai_day );
				if( im == ib+1 ) {
					Yasumi_red_t[sai_day[0]-1] = Color_table_bit[Opt_g.easter_color-1];
				}
			}
//Version 3.3 Add End
			for ( ih=0; ih<4; ih++ ) {
				if ( Opt_g.memorial_flag[ih] != 0 ) {
					if ((ia == Opt_g.memorial_year[ih] || Opt_g.memorial_year[ih] == 2999) && ib+1 == Opt_g.memorial_month[ih] ) {
						if ( Yasumi_red_t[Opt_g.memorial_day[ih]-1] == 0 ) {
							Yasumi_red_t[Opt_g.memorial_day[ih]-1] = Color_table_bit[Opt_g.memorial_col2[ih]-1];
						} else {
							Yasumi_red_t[Opt_g.memorial_day[ih]-1] = Color_table_bit[Opt_g.memorial_col1[ih]-1];
						}
					}
				}
			}
			ix = SetRedDataOfArray(ia, ib+1, &Yasumi_red_t[0], Yasumik_t);
		}
	}
}

//--------------------------------------------------------
//@tB[`̈f[^ݒ菈
//  Data setting of a feature.
//--------------------------------------------------------
static void Feature_Data_Set() {
	char work[20];
	MemHandle StringH;
	char      *StringP;
	short ia;

	StringH = DmGetResource(strRsc, StringEVERYYEAR);
	StringP = MemHandleLock(StringH);
	StrCopy(work, StringP);
	MemHandleUnlock(StringH);

	lstTable = (ListType *)GetObjectPtr(ModelStartYearCategoryList);
	Opt_g.st_year  = LstGetSelection(lstTable) + Start_year;
	lstTable = (ListType *)GetObjectPtr(ModelStartMonthCategoryList);
	Opt_g.st_month = LstGetSelection(lstTable) + 1;
	lstTable = (ListType *)GetObjectPtr(ModelEndYearCategoryList);
	Opt_g.en_year  = LstGetSelection(lstTable) + Start_year;
	lstTable = (ListType *)GetObjectPtr(ModelEndMonthCategoryList);
	Opt_g.en_month = LstGetSelection(lstTable) + 1;

	for ( ia=0; ia<WEEK_DAYS_NO; ia++ ) {
		Opt_g.week_color[ia] = LstGetSelection(GetObjectPtr(ModelWeekColorCategoryLists[ia]));
	}
	if ( CtlGetValue(GetObjectPtr(ModelNatHolidayCheckBox)) == 1 ) {
		Opt_g.hol_color = LstGetSelection(GetObjectPtr(ModelNatColorCategoryList));
	} else {
		Opt_g.hol_color = 99;
	}
//Version 3.3 Add Start
	if ( CtlGetValue(GetObjectPtr(ModelEasterCheckBox)) == 1 ) {
		Opt_g.easter_color = LstGetSelection(GetObjectPtr(ModelEasterColorCategoryList));
	} else {
		Opt_g.easter_color = 99;
	}
//Version 3.3 Add End
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean ModelHandleEvent (EventType * event){
	Boolean handled = false;
	short list_no, area_no, iz;

	frm = FrmGetFormPtr (Model);

	if (event->eType == penDownEvent){
		area_no = ColorRectCheck(event->screenX, event->screenY);
//Version 3.3 Update Start
		if ( (area_no != 99 && area_no != WEEK_DAYS_NO && area_no != WEEK_DAYS_NO+1 ) ||
		     (area_no == WEEK_DAYS_NO && Opt_g.hol_color != 99) ||
		     (area_no == WEEK_DAYS_NO+1 && Opt_g.easter_color != 99) ) {//FgI(A color frame is chosen.)
//Version 3.3 Update End
			list_no = LstPopupList(GetObjectPtr(ModelSunColorCategoryList+area_no*3));
			if ( list_no == Color_win_max_color + 1 ) {
				Color_call_win = 2;
				FrmGotoForm (ColorDefine);
			} else if ( list_no >= 0 ) {
				if ( area_no < WEEK_DAYS_NO ) {
					Opt_g.week_color[area_no] = list_no;
//Version 3.3 Update Start
				} else if ( area_no == WEEK_DAYS_NO ) {
					Opt_g.hol_color = list_no;
				} else {
					Opt_g.easter_color = list_no;
//Version 3.3 Update End
				}
				ColorRectDisp (list_no, area_no);

				if ( Opt_g.hol_count_flag == 1 ) {
//Version 3.3 Update Start
					if ( area_no < WEEK_DAYS_NO ) {
						EraseCom(X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
						DrawCom(list_no, X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
					} else if ( area_no == WEEK_DAYS_NO ) {
						EraseCom(X_HOL_CHAR, Y_HOL_CHAR);
						DrawCom(list_no, X_HOL_CHAR, Y_HOL_CHAR);
					} else {
						EraseCom(X_EASTER_CHAR, Y_EASTER_CHAR);
						DrawCom(list_no, X_EASTER_CHAR, Y_EASTER_CHAR);
//Version 3.3 Update End
					}
				}
			}
		}

	} else if (event->eType == penUpEvent){

	} else if (event->eType == keyDownEvent){
//		if (EvtKeydownIsVirtual(event)) {
//			if (event->data.keyDown.chr == vchrJogUp || //WO
//			    event->data.keyDown.chr == vchrPageUp) {//{^
//			} else if (event->data.keyDown.chr == vchrJogDown || //WO
//			           event->data.keyDown.chr == vchrPageDown) {//{^
//			} else if (event->data.keyDown.chr == vchrJogPush ||//WO
//			           event->data.keyDown.chr == vchrJogPushRepeat ||//WO
//			           event->data.keyDown.chr == vchrJogPushedUp ||//WO
//			           event->data.keyDown.chr == vchrJogPushedDown ) {//WO
//			}
//		}

	} else if (event->eType == popSelectEvent){
		area_no = 99;
		switch (event->data.ctlSelect.controlID){
		case ModelSunColorCategoryTrigger:
			area_no = 0; break;
		case ModelMonColorCategoryTrigger:
			area_no = 1; break;
		case ModelTueColorCategoryTrigger:
			area_no = 2; break;
		case ModelWedColorCategoryTrigger:
			area_no = 3; break;
		case ModelThuColorCategoryTrigger:
			area_no = 4; break;
		case ModelFriColorCategoryTrigger:
			area_no = 5; break;
		case ModelSatColorCategoryTrigger:
			area_no = 6; break;
		case ModelNatColorCategoryTrigger:
			area_no = 7; break;
//Version 3.3 Add Start
		case ModelEasterColorCategoryTrigger:
			area_no = 8; break;
//Version 3.3 Add End
		}
		if ( area_no != 99 ) {
			lstTable = (ListType *)GetObjectPtr(ModelSunColorCategoryList+area_no*3);
			if ( LstGetSelection(lstTable) == Color_win_max_color + 1 ) {
				Color_call_win = 2;
				FrmGotoForm (ColorDefine);
			} else if ( LstGetSelection(lstTable) >= 0 ) {
				if ( area_no < WEEK_DAYS_NO ) {
					Opt_g.week_color[area_no] = LstGetSelection(lstTable);
//Version 3.3 Update Start
				} else if ( area_no == WEEK_DAYS_NO ){
					Opt_g.hol_color = LstGetSelection(lstTable);
				} else {
					Opt_g.easter_color = LstGetSelection(lstTable);
//Version 3.3 Update End
				}
				ColorRectDisp (LstGetSelection(lstTable), area_no);

				if ( Opt_g.hol_count_flag == 1 ) {
//Version 3.3 Update Start
					if ( area_no < WEEK_DAYS_NO ) {
						EraseCom(X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
						DrawCom(LstGetSelection(lstTable), X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
					} else if ( area_no == WEEK_DAYS_NO ) {
						EraseCom(X_HOL_CHAR, Y_HOL_CHAR);
						DrawCom(LstGetSelection(lstTable), X_HOL_CHAR, Y_HOL_CHAR);
					} else {
						EraseCom(X_EASTER_CHAR, Y_EASTER_CHAR);
						DrawCom(LstGetSelection(lstTable), X_EASTER_CHAR, Y_EASTER_CHAR);
//Version 3.3 Update End
					}
				}
			}

		}

	} else if (event->eType == ctlSelectEvent){
		switch (event->data.ctlSelect.controlID){
		case ModelMemorialButton:
			Back_me_flag = 0;
			Feature_Data_Set();
			FrmGotoForm (MemorialWin);
			break;
		case ModelInitButton:
			Feature_Data_Set();
			if ( ( Opt_g.st_year > Opt_g.en_year ) || ( Opt_g.st_year == Opt_g.en_year && Opt_g.st_month > Opt_g.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			Dataupdateflag = 1;
			Hol_data_set(0);
			FrmGotoForm (MainWin);
			break;
		case ModelAddButton:
			Feature_Data_Set();
			if ( ( Opt_g.st_year > Opt_g.en_year ) || ( Opt_g.st_year == Opt_g.en_year && Opt_g.st_month > Opt_g.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			Dataupdateflag = 1;
			Hol_data_set(1);
			FrmGotoForm (MainWin);
			break;
		case ModelDeleteButton:
			Feature_Data_Set();
			if ( ( Opt_g.st_year > Opt_g.en_year ) || ( Opt_g.st_year == Opt_g.en_year && Opt_g.st_month > Opt_g.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			if ( FrmAlert(AltDelete) == 0 ) {
				DeleteRedDataOfArray(LstGetSelection((ListType *)GetObjectPtr(ModelStartYearCategoryList)) + Start_year,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelStartMonthCategoryList)) + 1,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelEndYearCategoryList)) + Start_year,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelEndMonthCategoryList)) + 1);
				Dataupdateflag = 1;
				FrmGotoForm (MainWin);
			}
			break;
		case ModelCancelButton:
			Opt_g.st_year      = Back_st_year;
			Opt_g.st_month     = Back_st_month;
			Opt_g.en_year      = Back_en_year;
			Opt_g.en_month     = Back_en_month;
			MemMove( &Opt_g.week_color[0], &Back_week_color[0], 14 );
			Opt_g.hol_color    = Back_hol_color;
//Version 3.3 Add Start
			Opt_g.easter_color = Back_easter_color;
//Version 3.3 Add End

			FrmGotoForm (MainWin);
			break;

//Version 3.3 Update Start
		case ModelNatHolidayCheckBox:
			iz = CtlGetValue(GetObjectPtr(ModelNatHolidayCheckBox));
			lstTable = (ListType *)GetObjectPtr(ModelNatColorCategoryList);
			if ( iz == 0 ) {
				Opt_g.hol_color = 99;
				LstSetSelection(lstTable, 0);
				CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
				CtlHideControl(GetObjectPtr(ModelNatColorCategoryTrigger));
				CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  false);
				ColorRectDisp (90, WEEK_DAYS_NO);
				EraseCom(X_HOL_CHAR, Y_HOL_CHAR);
			} else {
				Opt_g.hol_color = Hol_Color_Init;
				LstSetSelection(lstTable, Opt_g.hol_color);
				CtlShowControl(GetObjectPtr(ModelNatColorCategoryTrigger));
				CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  true);
				ColorRectDisp (Opt_g.hol_color, WEEK_DAYS_NO);
				DrawCom(Opt_g.hol_color, X_HOL_CHAR, Y_HOL_CHAR);
			}
			break;
//Version 3.3 Update End

//Version 3.3 Add Start
		case ModelEasterCheckBox:
			iz = CtlGetValue(GetObjectPtr(ModelEasterCheckBox));
			lstTable = (ListType *)GetObjectPtr(ModelEasterColorCategoryList);
			if ( iz == 0 ) {
				Opt_g.easter_color = 99;
				LstSetSelection(lstTable, 0);
				CtlSetLabel(GetObjectPtr(ModelEasterColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
				CtlHideControl(GetObjectPtr(ModelEasterColorCategoryTrigger));
				CtlSetEnabled(GetObjectPtr(ModelEasterColorCategoryTrigger),  false);
				ColorRectDisp (90, WEEK_DAYS_NO+1);
				EraseCom(X_EASTER_CHAR, Y_EASTER_CHAR);
			} else {
				Opt_g.easter_color = Easter_Color_Init;
				LstSetSelection(lstTable, Opt_g.easter_color);
				CtlShowControl(GetObjectPtr(ModelEasterColorCategoryTrigger));
				CtlSetEnabled(GetObjectPtr(ModelEasterColorCategoryTrigger),  true);
				ColorRectDisp (Opt_g.easter_color, WEEK_DAYS_NO+1);
				DrawCom(Opt_g.easter_color, X_EASTER_CHAR, Y_EASTER_CHAR);
			}
			break;
//Version 3.3 Add End
		}

	}else if (event->eType == menuEvent){
		switch (event->data.menu.itemID){
		case Option2ColorDefCmd:
			Color_call_win = 2;
			FrmGotoForm (ColorDefine);
			break;
		case Option2MemorialCmd:
			Back_me_flag = 0;
			FrmGotoForm (MemorialWin);
			break;
		case Option2AboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	}else if (event->eType == frmOpenEvent){
//Version 3.3 Add Start
		if ( Opt_g.hol_color != 99 ) {
			CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox), 1);
		} else {
			CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox), 0);
		}
		if ( Easter == 1 ) {
			CtlShowControl(GetObjectPtr(ModelEasterColorCategoryList));
			CtlShowControl(GetObjectPtr(ModelEasterCheckBox));
			if ( Opt_g.easter_color != 99 ) {
				CtlSetValue(GetObjectPtr(ModelEasterCheckBox), 1);
			} else {
				CtlSetValue(GetObjectPtr(ModelEasterCheckBox), 0);
			}
		} else {
			CtlHideControl(GetObjectPtr(ModelEasterColorCategoryTrigger));
			CtlHideControl(GetObjectPtr(ModelEasterColorCategoryList));
			CtlHideControl(GetObjectPtr(ModelEasterCheckBox));
		}
//Version 3.3 Add End

		if ( Back_md_flag == 0 ) {
			Back_st_year      = Opt_g.st_year;
			Back_st_month     = Opt_g.st_month;
			Back_en_year      = Opt_g.en_year;
			Back_en_month     = Opt_g.en_month;
			MemMove( &Back_week_color[0], &Opt_g.week_color[0], 14 );
			Back_hol_color    = Opt_g.hol_color;
//Version 3.3 Add Start
			Back_easter_color = Opt_g.easter_color;
//Version 3.3 Add End
		}
		Back_md_flag = 0;

		ModelInit ();
		FrmDrawForm (frm);
		WinDrawLine (  0, 30, 160,  30);
		WinDrawLine (105, 30, 105, 126);
		WinDrawLine (  0,126, 160, 126);
//Version 3.3 Update Start
		for ( iz=0; iz<WEEK_DAYS_NO; iz++ ) {//SUN-SAT
			ColorRectDisp (Opt_g.week_color[iz], iz);
			DrawCom(Opt_g.week_color[iz], X_WEEK_CHAR, Y_WEEK_CHAR+iz*Y_WEEKD);
		}
		if ( Opt_g.hol_color != 99 ) {
			ColorRectDisp (Opt_g.hol_color, WEEK_DAYS_NO);
			CtlShowControl(GetObjectPtr(ModelNatColorCategoryTrigger));
			DrawCom(Opt_g.hol_color, X_HOL_CHAR, Y_HOL_CHAR);
		} else {
			CtlHideControl(GetObjectPtr(ModelNatColorCategoryTrigger));
		}
		if ( Easter == 1 ) {
			if ( Opt_g.easter_color != 99 ) {
				ColorRectDisp (Opt_g.easter_color, WEEK_DAYS_NO+1);
				CtlShowControl(GetObjectPtr(ModelEasterColorCategoryTrigger));
				DrawCom(Opt_g.easter_color, X_EASTER_CHAR, Y_EASTER_CHAR);
			} else {
				CtlHideControl(GetObjectPtr(ModelEasterColorCategoryTrigger));
			}
		}
//Version 3.3 Update End
		handled = true;

	}else if (event->eType == frmUpdateEvent){
	}

	return (handled);
}
