//*****************************************************************************
//* Copyright (c) 2002-2004 Miday Workshop All rights reserved.
//*
//* File: Tools.c
//*****************************************************************************

#include <PalmOS.h>
#include <SonyCLIE.h>
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void ToolsInit () {
	Err err = errNone;
	unsigned short recordNo = 0;
	short flag;
	MemHandle StringH;
	char      *StringP;
	char delete_msg[200];

	flag = FileCheck(1, "");
	if ( flag != 0 ) {
		CtlShowControl(GetObjectPtr(ToolsDataFileButton));
		StringH = DmGetResource(strRsc, StringDeleteTitle);
		StringP = MemHandleLock(StringH);
		StrCopy(delete_msg, StringP);
		MemHandleUnlock(StringH);
		WinDrawChars (delete_msg, StrLen(delete_msg), 15, 27);
	}
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean ToolsHandleEvent (EventType * event) {
	Boolean handled = false;
	char filename[33], filename2[33];
	char *textP;
	MemHandle textH;
	FieldPtr fld;

	frm = FrmGetFormPtr (Tools);

	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case ToolsDataFileButton:
			if ( FrmAlert(AltDelDataFile) == 0 ) {
				FileDelete(cardNo, Dt_FileName);
				CtlHideControl(GetObjectPtr(ToolsDataFileButton));
			}
			Dataupdateflag = 0;
			Yasumi_no      = 0;
			break;
		case ToolsOKButton:
			FrmGotoForm (MainWin);
			handled = true;
			break;
		case ToolsColorFileExportButton:
			fld = GetObjectPtr (ToolsColorFileText);
			textH = FldGetTextHandle (fld);
			textP = MemHandleLock (textH);
			StrCopy (filename2, textP);
			MemPtrUnlock (textP);

			if ( StrCompare (filename2, "") == 0 ) {
				break;
			}
			
			StrCopy(filename, Col_FileName);
			StrCat (filename, filename2);
			StrCat (filename, Col_FileSuffix);

			if ( FileCheck(2, filename) == 1 ) {
				if ( FrmAlert(AltColorFileUpdate) == 1 ) {
					break;
				}
			}

			Md_SetDatabase(2, filename);
			SetColorFileCategory(ToolsColorFileCategoryList, ToolsColorFileCategoryTrigger, ToolsColorFileDeleteButton);
			FrmDrawForm (frm);
			break;
		case ToolsColorFileDeleteButton:
			if ( StrCompare (CtlGetLabel(GetObjectPtr(ToolsColorFileCategoryTrigger)),trigger_file_title) != 0 ) {
				if ( FrmAlert(AltDelColorFile) == 0 ) {
					StrCopy(filename, Col_FileName);
					StrCat (filename, CtlGetLabel(GetObjectPtr(ToolsColorFileCategoryTrigger)));
					StrCat (filename, Col_FileSuffix);
					FileDelete(cardNo, filename);
					SetColorFileCategory(ToolsColorFileCategoryList, ToolsColorFileCategoryTrigger, ToolsColorFileDeleteButton);
				}
			}
			CtlSetLabel(GetObjectPtr(ToolsColorFileCategoryTrigger), trigger_file_title);
			break;
		}

	} else if (event->eType == menuEvent) {
		switch (event->data.menu.itemID) {
		case AboutAboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	} else if (event->eType == frmOpenEvent) {
	
		fld = GetObjectPtr (ToolsColorFileText);
		textH = MemHandleNew (5);
		textP = MemHandleLock (textH);
		StrCopy(textP, "");
		MemPtrUnlock (textP);
		FldSetTextHandle (fld, textH);
	
		StrCopy (trigger_file_title, CtlGetLabel(GetObjectPtr(ToolsColorFileCategoryTrigger)));
		SetColorFileCategory(ToolsColorFileCategoryList, ToolsColorFileCategoryTrigger, ToolsColorFileDeleteButton);
		FrmDrawForm (frm);
		ToolsInit ();
		handled = true;
	}

	return (handled);
}
